//----------------------------------------------------------------------------
//                            TankSim.c
//
//      TankSim is a tank and heli-copter 3d wire frame graphics simulator
//      that has many neat features built into it:
//      keys-:
//      F1-F2  = Pan around the Tank or Heli-copter which ever is selected.
//      F3-F4  = Moves point of view up or down the Y axis.
//      F5-F6  = Moves point of view along  the Z axis from the object.
//      F7     = Increases / Decreases turning speed for selected object.
//      F8     = Tank mode = no action taken.
//      F8     = Heli mode = makes heli clime
//      F9     = Tank mode = Displays air craft hanger
//      F9     = Heli mode = Makes heli desend
//      F10    = Turns truck on or off - You can shoot and hit the truck !!!
//      PageDown= Selects either tank or Heli to control
//      This program was compiled using Borland C++ 3.0 but can be
//      compiled using TurboC 1.5-2.0 or maybe even converted over
//      to Pascal { Yuk !!! } just remove the // comment characters and
//      replace with the standard /* */  characters if using TurboC 1.5-2.0.
//      Contact as of Steve Cox II
//                    (713)-251-0734 HOUSTON GAME DESIGNER BBS
//                    or the C Language Echo if you can.
// P.S.  I know somethings could be changed to make the code better
//	 like passing arrays to functions but this was my first try!
//	 Also the EGAVGA.BGI must be used with this code!!!


#include <stdio.h>
#include <graphics.h>
#include <process.h>       //------- Compiled in <Small> -----------
#include <bios.h>          //------- memory module       -----------
#include <math.h>
#include "shapes.h"

//                   Declarations



#define TANK 1;
#define HELI 2;


char keyboard(void);
void quit_pgm(void);
void calc_3d(void);
void calc_3d3(void);
void draw_missle(void);
void draw_poly(void);
void explosion(int,int);
void draw_heli(void);
void helicontrol(void);
void tankcontrol(void);

void window(void);
void calc_2d(void);
void yaw_change(void);
void translation(void);
void crash(void);
void draw_horizon(void);
void horiz3d(void);
void corner(int,int,int,int);
void draw_object(int,int,int,int,int);
void grid(void);
void draw_grid(void);
void clip_3d(void);
void clip_2d(void);
void window_terrain(void);
void draw_line(void);
void draw_runway(int,int);
void draw_blg(int,int);
void draw_tower(int,int);
void draw_truck(int,int);
void draw_tank(void);
void calc_3d1(void);
void calc_3d2(int,int,int);



int t1=1,t2=1;
int p=0;
int c0=0,c1=1,c2=2,c3=3,c4=4,c5=5,c6=6,c7=7,c8=8,c9=9,c10=10,c11=11,
    c12=12,c13=13,c14=14,c15=15,mode_flag=0;             //colors
int p1=1;
int p2=1;
int g=7;
int GraphMode,GraphDriver,GraphMode,ErrorCode=0;

float x=0,y=0,z=0;
float x01=0,x2=0,x3=0,x4=0,x5=0,x6=0,x7=0,x8=0,x9=0,x10=0,x11=0,
      x12=0,x13=0,x14=0,x15=0,x16=0;                 //vertices of grid
float y01=0,y2=0,y3=0,y4=0,y5=0,y6=0,y7=0,y8=0,y9=0,y10=0,y11=0,
      y12=0,y13=0,y14=0,y15=0,y16=0;                 //vertices of grid
float z01=0,z2=0,z3=0,z4=0,z5=0,z6=0,z7=0,z8=0,z9=0,z10=0,z11=0,
      z12=0,z13=0,z14=0,z15=0,z16=0;                 //vertices of grid
float L=0;
float sx=0,sy=0;
float xa=0,ya=0,za=0;
float xb=0,yb=0,zb=0;
float xc=0,yc=0,zc=0;
float sxa=0,sya=0,sxb=0,syb=0;
float sxs=0,sys=0;
float temp_swap=0;

float d=620;
double r1=6.28319;
double r2=6.28319;
double r3=6.28319;
float r1a=0,r2a=0,r3a=0;
double sr1=0,sr2=0,sr3=0;
double cr1=0,cr2=0,cr3=0;
double ssr1=0,ssr2=0,ssr3=0;
double scr1=0,scr2=0,scr3=0;

float mx=75,my=-1,mz=-280;
float m=.5;
float m1=0;
float my1=0;
float mx1=0;
float mz1=0;
signed int mdir=0;


float  misx=0,misy=0,misz=0;
float  mismx=0,mismy=-2,mismz=0;
double misr1=0;
double misr2=0;
double misr3=0;

float  tankmx=0,tankmz=0,tankmy=0;
double tankr1=0;
double tankr2=0;
double tankr3=0;

float  helimx=0,helimz=0,helimy=10;
double helir1=3.2;
double helir2=0;
double helir3=0;

float maxx=639,minx=0,maxy=399,miny=0;
float c=0;
int layer=0,tankmode=1;
int crash_flag=0,towerflag=0,srcmx,srcmy,srcmz;
float rx=0,ry=0;
float screen_x=639,screen_y=399;
int fps=50,tz=0,mflag=0,expflag=0,timer=0;
int tflag=0,toffsetx=-15,toffsetz=-15,toffsety=-4,truckflag=0,bx=240,by=50;
float tangle=6.2,tx=500,turspeed=.025;
float time=0,ttime=0,htime=0,tview=4.5,misxhit,miszhit;
int pview=TANK;

//                         MAIN ROUTINES

main()
{



   Initialize();
   rx=screen_x/799;                            //define windowing ratio
   ry=screen_y/599;


   RESTART:                                    //jump to here after crash

   setactivepage(p);
   setvisualpage(1-p);
   p=1-p;                                      //setactive page

   ANIMATE:                                    //animation loop
   cleardevice();                              //blank the hidden page
   printf("\rPOSITION=X %4.1f Y %4.1f",tankmx,tankmz);
   if(tankmode) tankcontrol();
   else helicontrol();


   g=c1;
   draw_horizon();                       // set color and draw horizon
   draw_object(350,-500,2,0,1);          //draw object 1
   draw_object(1350,550,3,0,1);          //draw object 1
   draw_truck(tx-=.2,tz);
     draw_tank();
     draw_heli();
     draw_runway(-1,-1);
     draw_blg(bx,by);
     draw_tower(50,250);
     draw_missle();
     explosion(misxhit,miszhit);

   setcolor(c7);
   setactivepage(p);setvisualpage(1-p);p=1-p;   //flip pages
   goto ANIMATE;
}
//---------------------------------------------------------------------
void helicontrol(void)
{
     char key;

     mx=helimx+toffsetx*cos(tangle);       //point of view calculations
     mz=-helimz+toffsetz*sin(tangle);      //
     my=-helimy+toffsety;                  //

     r1=tview;
     if(r1>6.28319) r1-=6.28319;               //inhibit range of yaw angle
     if(r1<=0) r1+=6.28319;

     sr1=sin(r1);sr2=sin(r2);sr3=sin(r3);	//new sine factors
     cr1=cos(r1);cr2=cos(r2);cr3=cos(r3);	//new cosine factors

       key=keyboard();
       switch(key)
	{
/*Esc*/	   case 27: quit_pgm();   //quit program
/*spcbar*/ case 32: if(mflag==1) return;
			misr1=helir1+3.2;
			srcmx=helimx;
			srcmy=helimy;
			srcmz=helimz;
			mflag=1;
			return;
/* F1 */   case 59: tangle+=turspeed;tview+=turspeed;return;
/* F2 */   case 60: tangle-=turspeed;tview-=turspeed;return;
/* F3 */   case 61: toffsety-=1;return;
/* F4 */   case 62: toffsety+=1;return;
/* F5 */   case 63: toffsetz+=1;toffsetx+=1;return;
/* F6*/    case 64: toffsetz-=1;toffsetx-=1;return;
/* F7 */   case 65: turspeed+=.1;if(turspeed>.2) turspeed=.025;return;
/* F8 */   case 66: helimy+=.5;return;
/* F9 */   case 67: helimy-=.5;return;
/* F10*/   case 68: truckflag+=1;if(truckflag>1) truckflag=0;return;
/*left*/   case 75: helir1+=turspeed;return;
/*rght*/   case 77: helir1-=turspeed;return;
/*up*/     case 72: htime+=1;if(htime>=5) htime=5;
		    helir2+=.1;return;                      //+ key increase throttle
/*dwn*/    case 80: htime-=1;if(htime<=0) htime=0;
		    helir2-=.1;return; //- key decrease throttle
/*pgup*/   case 73: pview=1;return;
/*pgdwn*/  case 81: tankmode+=1;if(tankmode > 1) tankmode=0;return;
	}
	   return;
}

//---------------------------------------------------------------------
void tankcontrol(void)
{
     char key;


       mx=tankmx+toffsetx*cos(tangle);       //point of view calculations
       mz=-tankmz+toffsetz*sin(tangle);      //
       my=-tankmy+toffsety;                  //

     r1=tview;
     if(r1>6.28319) r1-=6.28319;               //inhibit range of yaw angle
     if(r1<=0) r1+=6.28319;

     sr1=sin(r1);sr2=sin(r2);sr3=sin(r3);	//new sine factors
     cr1=cos(r1);cr2=cos(r2);cr3=cos(r3);	//new cosine factors

       key=keyboard();
       switch(key)
	{
/*Esc*/	   case 27: quit_pgm();   //quit program
/*spcbar*/ case 32: if(mflag==1) return;
		    misr1=tankr1;
		    srcmx=tankmx;
		    srcmy=tankmy+3;
		    srcmz=tankmz;
		    mflag=1;
		    return;
/* F1 */   case 59: tangle+=turspeed;tview+=turspeed;return;
/* F2 */   case 60: tangle-=turspeed;tview-=turspeed;return;
/* F3 */   case 61: toffsety-=1;return;
/* F4 */   case 62: toffsety+=1;return;
/* F5 */   case 63: toffsetz+=1;toffsetx+=1;return;
/* F6*/    case 64: toffsetz-=1;toffsetx-=1;return;
/* F7 */   case 65: turspeed+=.1;if(turspeed>.2) turspeed=.025;return;
/* F8 */   case 66: return;
/* F9 */   case 67: towerflag+=1;if(towerflag>1) towerflag=0;return;
/* F10*/   case 68: truckflag+=1;if(truckflag>1) truckflag=0;return;
/*left*/   case 75: tankr1+=turspeed;return;
/*rght*/   case 77: tankr1-=turspeed;return;
/*up*/     case 72: ttime+=.1;if(ttime>=2) ttime=2;return; //+ key increase throttle
/*dwn*/    case 80: ttime-=.1;if(ttime<=0) ttime=0;return;  //- key decrease throttle
/*pgup*/   case 73: pview=2;return;
/*pgdwn*/  case 81: tankmode+=1;if(tankmode > 1) tankmode=0; return;
	}
	   return;
}
//-----------------------------------------------------------------------
void draw_tank(void)
{
   int t,p2=0;

   if(mismx < tankmx+5 && mismx > tankmx-5 &&
      mismz < tankmz+5 && mismz > tankmz-5 && mflag == 1 && misy < 10)
	      { expflag=1;
		mflag=0;
		time=0;
		misxhit=tankmx;
		miszhit=tankmz;
		mismx=0;
		mismz=0;
		tankmx=0.0;
		tankmz=0.0;
		return;
	       }

     ssr1=sin(tankr1);
     scr1=cos(tankr1);

     tankmx+=scr1*ttime;           //calc for x incrementation
     tankmz+=ssr1*ttime;           //calc for z incrementation

  for(t=0;t<44;t++)
  {
    x=tank[p2][0];
    y=tank[p2][1];            //get point one values
    z=tank[p2][2];
    xa=scr1*x-ssr1*z;     //yaw
    za=ssr1*x+scr1*z;     //yaw
    z=1*za-0*y;           //pitch
    ya=0*za+1*y;          //pitch
    x=1*xa+0*ya;          //roll
    y=1*ya-0*xa;          //roll

    x+=tankmx;                   //inc along x axis
    z+=tankmz;                   //inc along z axis
    y+=tankmy;
    calc_3d();                 //calc 3d  perspective

    x01=x;y01=y;z01=z;
    p2++;                       //increment array counter
    x=tank[p2][0];
    y=tank[p2][1];            //get point two values
    z=tank[p2][2];
    xa=scr1*x-ssr1*z;           //yaw
    za=ssr1*x+scr1*z;           //yaw
    z=1*za-0*y;           //pitch
    ya=0*za+1*y;          //pitch
    x=1*xa+0*ya;          //roll
    y=1*ya-0*xa;          //roll

    x+=tankmx;
    z+=tankmz;
    y+=tankmy;
    calc_3d();                  //calc 3d perspective
    x2=x;y2=y;z2=z;
    setcolor(g);
    xa=x01;ya=y01;za=z01;       //load calculated variables
    xb=x2;yb=y2;zb=z2;
    p1=1;                       //clip line to be drawn
    clip_3d();
    if(p1==1)draw_line();       //draw the line
    p2++;

   }

    return;
}
//-----------------------------------------------------------------------
void draw_heli(void)
{
   int t,p2=0;

	  ssr1=sin(helir1);ssr2=sin(helir2);ssr3=sin(helir3);
	  scr1=cos(helir1);scr2=cos(helir2);scr3=cos(helir3);

     helimx+=scr1*-htime;           //calc for x incrementation
     helimz+=ssr1*-htime;           //calc for z incrementation


  for(t=0;t<53;t++)
  {
    x=chop[p2][0];
    y=chop[p2][1];            //get point one values
    z=chop[p2][2];
    xa=scr1*x-ssr1*z;           //yaw
    za=ssr1*x+scr1*z;           //yaw
    z=scr3*za-ssr3*y;           //pitch
    ya=ssr3*za+scr3*y;          //pitch
    x=scr2*xa+ssr2*ya;          //roll
    y=scr2*ya-ssr2*xa;          //roll
    x+=helimx;            //inc along x axis
    y+=helimy;            //inc along y axis
    z+=helimz;            //inc along z axis
    calc_3d();                  //calc 3d  perspective

    x01=x;y01=y;z01=z;
    p2++;                       //increment array counter
    x=chop[p2][0];
    y=chop[p2][1];            //get point two values
    z=chop[p2][2];
    xa=scr1*x-ssr1*z;           //yaw
    za=ssr1*x+scr1*z;           //yaw
    z=scr3*za-ssr3*y;           //pitch
    ya=ssr3*za+scr3*y;          //pitch
    x=scr2*xa+ssr2*ya;          //roll
    y=scr2*ya-ssr2*xa;          //roll
    x+=helimx;
    y+=helimy;
    z+=helimz;
    calc_3d();                  //calc 3d perspective
    x2=x;y2=y;z2=z;
    setcolor(g);
    xa=x01;ya=y01;za=z01;       //load calculated variables
    xb=x2;yb=y2;zb=z2;
    p1=1;                       //clip line to be drawn
    clip_3d();
    if(p1==1)draw_line();       //draw the line
    p2++;

   }

    return;
}
//-----------------------------------------------------------------------
void draw_missle(void)
{
   int t,p2=0;

   if(mflag == 0) {time=0;return;}      // if no missle shot return

	  ssr1=sin(misr1);
	  scr1=cos(misr1);


		   //missile trajectory calculation

     mismx=srcmx+scr1*150*(time+=.05);           //calc for x incrementation
     mismz=srcmz+ssr1*150*time;                 //calc for z incrementation
     mismy=srcmy+(-1)*(time*time);                   //calc rate of fall
       if(mismy < 0) {mflag=0;
		      time=0;
		      return;}  //if missle hits the ground reset

  for(t=0;t<9;t++)
  {
    x=missile[p2][0];
    y=missile[p2][1];            //get point one values
    z=missile[p2][2];
    xa=scr1*x-ssr1*z;           //yaw
    za=ssr1*x+scr1*z;           //yaw
    z=scr3*za-ssr3*y;           //pitch
    ya=ssr3*za+scr3*y;          //pitch
    x=scr2*xa+ssr2*ya;          //roll
    y=scr2*ya-ssr2*xa;          //roll
    x+=mismx;            //inc along x axis
    y+=mismy;            //inc along y axis
    z+=mismz;            //inc along z axis
    calc_3d();                  //calc 3d  perspective

    x01=x;y01=y;z01=z;
    p2++;                       //increment array counter
    x=missile[p2][0];
    y=missile[p2][1];            //get point two values
    z=missile[p2][2];
    xa=scr1*x-ssr1*z;           //yaw
    za=ssr1*x+scr1*z;           //yaw
    z=scr3*za-ssr3*y;           //pitch
    ya=ssr3*za+scr3*y;          //pitch
    x=scr2*xa+ssr2*ya;          //roll
    y=scr2*ya-ssr2*xa;          //roll
    x+=mismx;
    y+=mismy;
    z+=mismz;
    calc_3d();                  //calc 3d perspective
    x2=x;y2=y;z2=z;
    setcolor(g);
    xa=x01;ya=y01;za=z01;       //load calculated variables
    xb=x2;yb=y2;zb=z2;
    p1=1;                       //clip line to be drawn
    clip_3d();
    if(p1==1)draw_line();       //draw the line
    p2++;

   }

    return;
}
//-----------------------------------------------------------------------
void draw_blg(int xloc,int yloc)
{
   int t,p2=0;
   int segments=28;

   if(mismx < xloc+5 && mismx > xloc-5 &&
      mismz < yloc+5 && mismz > yloc-5)
	      { expflag=1;
		mflag=0;
		time=0;
		misxhit=xloc;
		miszhit=yloc;
		mismx=0;
		mismz=0;
		bx=rand()%1000;
		by=rand()%1000;
		}


  for(t=0;t<segments;t++)
  {
    x=xloc+blg[p2][0];
    y=blg[p2][1];            //get point one values
    z=yloc+blg[p2][2];
    calc_3d();                  //calc 3d  perspective

    x01=x;y01=y;z01=z;
    p2++;                       //increment array counter
    x=xloc+blg[p2][0];
    y=blg[p2][1];            //get point two values
    z=yloc+blg[p2][2];
    calc_3d();                  //calc 3d perspective

    x2=x;y2=y;z2=z;
    setcolor(g);
    xa=x01;ya=y01;za=z01;       //load calculated variables
    xb=x2;yb=y2;zb=z2;
    p1=1;                       //clip line to be drawn
    clip_3d();
    if(p1==1)draw_line();       //draw the line
    p2++;
   }
    return;
}
//-----------------------------------------------------------------------
void draw_truck(int xloc,int yloc)
{
   int t,p2=0;
   static int dead;

   if(truckflag == 0) {tx=500;tz=0;return;}

   if(mismx < xloc+3 && mismx > xloc-3 &&
      mismz < yloc+3 && mismz > yloc-3)
	      { expflag=1;
		mflag=0;
		time=0;
		misxhit=xloc;
		miszhit=yloc;
		mismx=0;
		mismz=0;
		truckflag=0;
		}


  for(t=0;t<71;t++)
  {
    x=xloc+truck[p2][0];
    y=truck[p2][1];            //get point one values
    z=yloc+truck[p2][2];
    calc_3d();                  //calc 3d  perspective
    x01=x;y01=y;z01=z;
    p2++;                       //increment array counter
    x=xloc+truck[p2][0];
    y=truck[p2][1];            //get point two values
    z=yloc+truck[p2][2];
    calc_3d();                  //calc 3d perspective
    x2=x;y2=y;z2=z;
    setcolor(g);
    xa=x01;ya=y01;za=z01;       //load calculated variables
    xb=x2;yb=y2;zb=z2;
    p1=1;                       //clip line to be drawn
    clip_3d();
    if(p1==1)draw_line();       //draw the line
    p2++;
   }
    return;
}
//-----------------------------------------------------------------------
void explosion(int xloc,int yloc)
{
   int t,p2=0;

   if(expflag != 1) return;          // if no missle hit ground return
   if(timer++ > 15) {expflag=0;timer=0;return;}


  for(t=0;t<24;t++)
  {
    x=xloc+explode[p2][0];
    y=explode[p2][1];            //get point one values
    z=yloc+explode[p2][2];

    calc_3d();                  //calc 3d  perspective
    x01=x;y01=y;z01=z;
    p2++;                       //increment array counter
    x=xloc+explode[p2][0];
    y=explode[p2][1];            //get point two values
    z=yloc+explode[p2][2];

    calc_3d();                  //calc 3d perspective
    x2=x;y2=y;z2=z;
    setcolor(g);
    xa=x01;ya=y01;za=z01;       //load calculated variables
    xb=x2;yb=y2;zb=z2;
    p1=1;                       //clip line to be drawn
    clip_3d();
    if(p1==1)draw_line();       //draw the line
    p2++;

   }
    return;
}
//-----------------------------------------------------------------------
void draw_tower(int xloc,int yloc)
{
   int t,p2=0;

    if(towerflag == 0) return;

  for(t=0;t<51;t++)
  {
    x=xloc+tower[p2][0];
    y=tower[p2][1];            //get point one values
    z=yloc+tower[p2][2];
    calc_3d();                  //calc 3d  perspective
    x01=x;y01=y;z01=z;
    p2++;                       //increment array counter
    x=xloc+tower[p2][0];
    y=tower[p2][1];            //get point two values
    z=yloc+tower[p2][2];
    calc_3d();                  //calc 3d perspective
    x2=x;y2=y;z2=z;
    setcolor(g);
    xa=x01;ya=y01;za=z01;       //load calculated variables
    xb=x2;yb=y2;zb=z2;
    p1=1;                       //clip line to be drawn
    clip_3d();
    if(p1==1)draw_line();       //draw the line
    p2++;
   }
    return;
}
//-----------------------------------------------------------------------
void draw_runway(int xloc,int yloc)
{
   int t,p2=0;


  for(t=0;t<5;t++)
  {
    x=xloc+array2[p2][0];
    y=array2[p2][1];            //get point one values
    z=yloc+array2[p2][2];
    calc_3d();                  //calc 3d  perspective
    x01=x;y01=y;z01=z;
    p2++;                       //increment array counter
    x=xloc+array2[p2][0];
    y=array2[p2][1];            //get point two values
    z=yloc+array2[p2][2];
    calc_3d();                  //calc 3d perspective
    x2=x;y2=y;z2=z;
    setcolor(g);
    xa=x01;ya=y01;za=z01;       //load calculated variables
    xb=x2;yb=y2;zb=z2;
    p1=1;                       //clip line to be drawn
    clip_3d();
    if(p1==1)draw_line();       //draw the line
    p2++;
   }
    return;
}
//------------------------------------------------------------------------
void  calc_3d(void)
{

   x=x-mx;
   y=y+my;
   z=z+mz;                      //translation
   xa=cr1*x-sr1*z;
   za=sr1*x+cr1*z;           //yaw
   z=cr3*za-sr3*y;
   ya=sr3*za+cr3*y;          //pitch
   x=cr2*xa+sr2*ya;
   y=cr2*ya-sr2*xa;          //roll
   return;
}
//------------------------------------------------------------------------
void horiz3d(void)
{
   x=(-1)*x;
   za=cr3*z-sr3*y;
   ya=sr3*z+cr3*y;
   xa=cr2*x+sr2*ya;
   y=cr2*ya-sr2*x;
   sx=d*xa/za;
   sy=d*y/za;
   return;
}
//-----------------------------------------------------------------------
void draw_object(int x_loc,int y_loc,int squarew,int layer,int loop)
{
   int tms;

  for(tms=loop;tms>0;tms--)
   {
    corner(x_loc,y_loc,squarew,layer); //calculate coords for corners of terrain map
    g=c2;
    draw_grid();
    layer+=30;
   }
}
//-----------------------------------------------------------------------
void corner(int x_loc,int y_loc,int squ,int layer)
{
    x=x_loc+(-squ);y=layer;z=y_loc+(-squ);calc_3d();x01=x;y01=y;z01=z;
    x=x_loc+squ;y=layer;z=y_loc+(-squ);calc_3d();x2=x;y2=y;z2=z;
    x=x_loc+squ;y=layer;z=y_loc+squ;calc_3d();x3=x;y3=y;z3=z;
    x=x_loc+(-squ);y=layer;z=y_loc+squ;calc_3d();x4=x;y4=y;z4=z;
    return;
}
//-------------------------------------------------------------------------
void draw_grid(void)
{

  setcolor(g);
  xa=x01;ya=y01;za=z01;xb=x2;yb=y2;zb=z2;p1=1;clip_3d();
  if(p1==1)draw_line();
  xa=x4;ya=y4;za=z4;xb=x3;yb=y3;zb=z3;p1=1;clip_3d();
  if(p1==1)draw_line();
  xa=x01;ya=y01;za=z01;xb=x4;yb=y4;zb=z4;p1=1;clip_3d();
  if(p1==1)draw_line();
  xa=x2;ya=y2;za=z2;xb=x3;yb=y3;zb=z3;p1=1;clip_3d();
  if(p1==1)draw_line();
  return;
}
//-----------------------------------------------------------------------
void draw_horizon(void)
{

   if(r3>1.57079){                 //test for inverted flight
   if(r3<4.71239) goto INVERTED;
   };

   x=-8000;y=0;z=-10000;          //left world coordinates of horizon
   horiz3d();                      //calculate unclipped display coordinates
   window();                       //map display coords to fit 640X480 display
   sxa=sx;sya=sy;                  //left end of line
   x=8000;y=0;z=-10000;            //right world coordinates of horizon
   horiz3d();                      //calculate unclipped display coordinates
   window();                       //map display coords to fit 640X480 display
   sxb=sx;syb=sy;                  //right end of line
   clip_2d();                      //clip line to fit display
   setcolor(g);
   moveto(sxa,sya);
   lineto(sxb,syb);                //draw line
   return;

   INVERTED:                        //same as above but (-1)*z*
   x=-8000;y=0;z=10000;           //left world coordinates of horizon
   horiz3d();                      //calculate unclipped display coordinates
   window();                       //map display coords to fit 640X480 display
   sxa=sx;sya=sy;                  //left end of line
   x=8000;y=0;z=10000;             //right world coordinates of horizon
   horiz3d();                      //calculate unclipped display coordinates
   window();                       //map display coords to fit 640X480 display
   sxb=sx;syb=sy;                  //right end of line
   clip_2d();                      //clip line to fit display
   setcolor(g);
   moveto(sxa,sya);
   lineto(sxb,syb);               //draw line
   return;
}
//------------------------------------------------------------------------
void clip_2d(void)
{

   if(sxa>sxb) { temp_swap=sxa;sxa=sxb;sxb=temp_swap;
   temp_swap=sya;sya=syb;syb=temp_swap;};

   if(sxa<minx) {if(sxb<minx) {p2=0;return;}}
   if(sxa>maxx) {if(sxb>maxx) {p2=0;return;}}
   if(sya<miny) {if(syb<miny) {p2=0;return;}}
   if(sya>maxy) {if(syb>maxy) {p2=0;return;}}

   if(sxa<minx) {{c=(syb-sya)/(sxb-sxa)*(sxb-minx);    //push right
   sxa=minx;sya=syb-c;};
   if(sya<miny) if(syb<miny) return;
   if(sya>maxy) if(syb>maxy) return;
   };

   if(sxb>maxx) {{c=(syb-sya)/(sxb-sxa)*(maxx-sxa);    //push left
   sxb=maxx;syb=sya+c;};
   if(sya<miny) if(syb<miny) return;
   if(sya>maxy) if(syb>maxy) return;
   };

   if(sya>syb) { temp_swap=sya;sya=syb;syb=temp_swap;
   temp_swap=sxa;sxa=sxb;sxb=temp_swap;};

   if(sya<miny) {c=(sxb-sxa)/(syb-sya)*(syb-miny);     //push down
   sxa=sxb-c;sya=miny;};

   if(syb>maxy) {c=(sxb-sxa)/(syb-sya)*(maxy-sya);     //push up
   sxb=sxa+c;syb=maxy;};
   return;
}
//-----------------------------------------------------------------------
void draw_line(void)
{

   p2=1;
   clip_2d();                 //p2 will be set to zero if line is invisible
   if(p2==1) {
   moveto(sxa,sya);
   lineto(sxb,syb);
   }
   return;
}
//------------------------------------------------------------------------
void window(void)
{
   sx=sx+399;
   sy=sy+299;
   rx=screen_x/799;
   ry=screen_y/599;
   sx=sx*rx;
   sy=sy*ry;
   return;
}
//----------------------------------------------------------------------
void window_terrain(void)
{

  sxa=sxa+399;
  sya=sya+299;
  sxa=sxa*rx;
  sya=sya*ry;
  sxb=sxb+399;
  syb=syb+299;
  sxb=sxb*rx;
  syb=syb*ry;
  return;
}
//-----------------------------------------------------------------------
void clip_3d(void)
{

  if(za>=-1) goto LABEL1630;            //xa,ya,za requires clipping
  goto LABEL1640;                       //xa,ya,za are o.k.

  LABEL1630:                            //both endpoints hidden
  if(zb>=-1) {p1=0;return;};
  temp_swap=xb;xb=xa;xa=temp_swap;
  temp_swap=yb;yb=ya;ya=temp_swap;
  temp_swap=zb;zb=za;za=temp_swap;
  goto LABEL1660;                       //only xb,yb,zb requires clipping

  LABEL1640:                     //xa,ya,za is o.k., now test xb,yb,zb
  if(zb>=-1) goto LABEL1660;     //only xb,yb,zb requires clipping

  LABEL1650:                     //calc display coords and map to screen
  sxa=d*xa/za;
  sya=d*ya/za;
  sxb=d*xb/zb;
  syb=d*yb/zb;
  window_terrain();
  return;

  LABEL1660:                     //clip xb,yb,zb
  c=(xb-xa)/(zb-za)*(zb+1);
  xc=xb-c;
  c=(yb-ya)/(zb-za)*(zb+1);
  yc=yb-c;
  zc=-1;
  xb=xc;
  yb=yc;
  zb=zc;
  goto LABEL1650;

}
//----------------------------------------------------------------------
char keyboard(void)
{
 union u_type{int a;char b[3];} keystroke;
 char inkey=0;
 if (bioskey(1)==0) {return;}
 keystroke.a=bioskey(0);
 inkey=keystroke.b[0];
 if (inkey!=0) return(inkey);		         //normal key depressed
 if (inkey==0) return(inkey=keystroke.b[1]);    //else extended key
     return;
}
//------------------------------------------------------------------------
void quit_pgm(void)
{
    setvisualpage(0);setactivepage(0);
    cleardevice();
    restorecrtmode();
    exit(0);
}
/*----------------------------------------------------------------------*/
Initialize()
{
	 GraphDriver=DETECT;
	 initgraph(&GraphDriver,&GraphMode,"");
	 ErrorCode=graphresult();
	 if (ErrorCode!=grOk)
	  {
	    printf("Graphics Error:%s\n",grapherrormsg(ErrorCode));
	    exit(1);
	  }
	  setgraphmode(VGAMED);
	  return(0);
}








































































































